#ifndef MSP_GL_UNLITMATERIAL_H_
#define MSP_GL_UNLITMATERIAL_H_

#include "material.h"

namespace Msp {
namespace GL {

class UnlitMaterial: public Material
{
public:
	class Loader: public DataFile::DerivedObjectLoader<UnlitMaterial, Material::PropertyLoader<UnlitMaterial> >
	{
	private:
		static ActionMap shared_actions;

	public:
		Loader(UnlitMaterial &);
		Loader(UnlitMaterial &, Collection &);

	private:
		virtual void init_actions();

		void texture(const std::string &);
	};

private:
	const Texture *texture;
	Color color;
	bool vertex_color;

	static const Tag texture_tags[];

public:
	UnlitMaterial();

protected:
	virtual void fill_program_info(std::string &, std::map<std::string, int> &) const;

public:
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
	DEPRECATED virtual void attach_textures_to(Texturing &, ProgramData &) const;
#pragma GCC diagnostic pop

	virtual const Tag *get_texture_tags() const { return texture_tags; }
	virtual const Texture *get_texture(Tag) const;

	void set_texture(const Texture *);
	void set_color(const Color &);
	void set_vertex_color(bool);
};

} // namespace GL
} // namespace Msp

#endif
